	; IntyBASIC compiler v0.2 Feb/03/2014
        ;
        ; Prologue for IntyBASIC programs
        ; by Oscar Toledo G.  http://nanochess.org/
        ;
        ; Revision: Jan/30/2014. Spacing adjustment and more comments.

        ROMW 16
        ORG $5000
        
        ;
        ; ROM header
        ;
        BIDECLE _ZERO           ; MOB picture base
        BIDECLE _ZERO           ; Process table
        BIDECLE _MAIN           ; Program start
        BIDECLE _ZERO           ; Background base image
        BIDECLE _ONES           ; GRAM
        BIDECLE _TITLE          ; Cartridge title and date
        DECLE   $03C0           ; No ECS title, inits code after title,
                                ; ... no clicks
                                
_ZERO:  DECLE   $0000           ; Border control
        DECLE   $0000           ; 0 = color stack, 1 = f/b mode
        
_ONES:  DECLE   $0001, $0001    ; Initial color stack 0 and 1: Blue
        DECLE   $0001, $0001    ; Initial color stack 2 and 3: Blue
        DECLE   $0001           ; Initial border color: Blue

C_WHT:  EQU $0007

CLRSCR: MVII #$200,R4           ; Used also for CLS
        MVII #$F0,R1
FILLZERO:
        CLRR R0
MEMSET:
        MVO@ R0,R4
        DECR R1
        BNE MEMSET
        JR R5

        ;
        ; Title, avoid and jump directly into main program
        ;
_TITLE: PROC
        BYTE    114, 'IntyBASIC program', 0
;        BEGIN

;        RETURN                  ; Return to EXEC for title screen display
        ENDP

        ;
        ; Main program
        ;
_MAIN:
        DIS
        MVII #STACK,R6

_MAIN0:
        ;
        ; Clean memory
        ;
        MVII #$0fe,R1           ; 240 words of 8 bits plus 14 of sound
        MVII #$100,R4           ; 8-bit scratch RAM
        CALL FILLZERO
        MVII #$040,R1           ; 64 words of 16 bits
        MVII #$320,R4           ; 16-bit scratch RAM
        CALL FILLZERO

        CALL CLRSCR             ; Clean up screen

        MVII #_int_vector,R0 ; Points to interrupt vector
        MVO R0,ISRVEC
        SWAP R0
        MVO R0,ISRVEC+1
        MVII #2,R0
        MVO R0,_first_time

        EIS
        MVII #7,R0
        MVO R0,_color           ; Default color for PRINT "string"
        MVII #$038,R0
        MVO R0,$01F8            ; Configures sound
	; 	REM
	; 	REM Example MOBs (sprites)
	; 	REM Demo for IntyBASIC
	; 	REM by Oscar Toledo G. http://nanochess.org
	; 	REM Jan/27/2014
	; 	REM
	; 
	; 	WAIT
	CALL _wait
	; 	DEFINE 0,4,drawings
	MVII #0,R0
	MVO R0,_gram_target
	MVII #4,R0
	MVO R0,_gram_total
	MVII #Q1,R4
	MVO R4,_gram_bitmap
	MVII #1,R0
	MVO R0,_load_gram
	; 	WAIT
	CALL _wait
	; 	x1=80
	MVII #80,R0
	MVO R0,V1
	; 	y1=56
	MVII #56,R0
	MVO R0,V2
	; 
	; loop:
	; LOOP
Q2:	; 	FOR X=0 TO 80
	CLRR R0
	MVO R0,V3
T1:
	; 	WAIT
	CALL _wait
	; 	SPRITE 0,40+X + $600,20+$100,$0807
	MVII #40,R0
	ADD V3,R0
	ADDI #1536,R0
	MVO R0,_mobs+0
	MVII #276,R0
	MVO R0,_mobs+8
	MVII #2055,R0
	MVO R0,_mobs+16
	; 	SPRITE 1,120-X + $600,60+$100,$0801
	MVII #120,R0
	SUB V3,R0
	ADDI #1536,R0
	MVO R0,_mobs+1
	MVII #316,R0
	MVO R0,_mobs+9
	MVII #2049,R0
	MVO R0,_mobs+17
	; 	SPRITE 2,20 + $600,X+8+$100,$0812
	MVII #1556,R0
	MVO R0,_mobs+2
	MVI V3,R0
	ADDI #8,R0
	ADDI #256,R0
	MVO R0,_mobs+10
	MVII #2066,R0
	MVO R0,_mobs+18
	; 	SPRITE 3,140 + $600,(96-X)+$100,$081B
	MVII #1676,R0
	MVO R0,_mobs+3
	MVII #96,R0
	SUB V3,R0
	ADDI #256,R0
	MVO R0,_mobs+11
	MVII #2075,R0
	MVO R0,_mobs+19
	; 	SPRITE 4,X1+$600,Y1+$100,$081D
	MVI V1,R0
	ADDI #1536,R0
	MVO R0,_mobs+4
	MVI V2,R0
	ADDI #256,R0
	MVO R0,_mobs+12
	MVII #2077,R0
	MVO R0,_mobs+20
	; 	GOSUB test
	CALL Q3
	; 	NEXT X
	MVII #80,R0
	CMP V3,R0
	BLE T2
	MVI V3,R0
	INCR R0
	MVO R0,V3
	B T1
T2:
	; 
	; 	FOR X=80 TO 0 STEP -1
	MVII #80,R0
	MVO R0,V3
T3:
	; 	WAIT
	CALL _wait
	; 	SPRITE 0,40+X + $600,20+$100,$0807
	MVII #40,R0
	ADD V3,R0
	ADDI #1536,R0
	MVO R0,_mobs+0
	MVII #276,R0
	MVO R0,_mobs+8
	MVII #2055,R0
	MVO R0,_mobs+16
	; 	SPRITE 1,120-X + $600,60+$100,$0801
	MVII #120,R0
	SUB V3,R0
	ADDI #1536,R0
	MVO R0,_mobs+1
	MVII #316,R0
	MVO R0,_mobs+9
	MVII #2049,R0
	MVO R0,_mobs+17
	; 	SPRITE 2,20 + $600,X+8+$100,$0812
	MVII #1556,R0
	MVO R0,_mobs+2
	MVI V3,R0
	ADDI #8,R0
	ADDI #256,R0
	MVO R0,_mobs+10
	MVII #2066,R0
	MVO R0,_mobs+18
	; 	SPRITE 3,140 + $600,(96-X)+$100,$081B
	MVII #1676,R0
	MVO R0,_mobs+3
	MVII #96,R0
	SUB V3,R0
	ADDI #256,R0
	MVO R0,_mobs+11
	MVII #2075,R0
	MVO R0,_mobs+19
	; 	SPRITE 4,X1+$600,Y1+$100,$081D
	MVI V1,R0
	ADDI #1536,R0
	MVO R0,_mobs+4
	MVI V2,R0
	ADDI #256,R0
	MVO R0,_mobs+12
	MVII #2077,R0
	MVO R0,_mobs+20
	; 	GOSUB test
	CALL Q3
	; 	NEXT X
	CLRR R0
	CMP V3,R0
	BGE T4
	MVI V3,R0
	DECR R0
	MVO R0,V3
	B T3
T4:
	; 
	; 	GOTO loop
	B Q2
	; 
	; test:	PROCEDURE
	; TEST
Q3:	PROC
	BEGIN
	; 	IF CONT1.UP THEN IF Y1>0 THEN Y1=Y1-1
	MVI 511,R0
	COMR R0
	ANDI #4,R0
	TSTR R0
	BEQ T5
	MVI V2,R0
	CMPI #0,R0
	BLE T6
	MVI V2,R0
	DECR R0
	MVO R0,V2
T6:
T5:
	; 	IF CONT1.DOWN THEN IF Y1<104 THEN Y1=Y1+1
	MVI 511,R0
	COMR R0
	ANDI #1,R0
	TSTR R0
	BEQ T8
	MVI V2,R0
	CMPI #104,R0
	BGE T9
	MVI V2,R0
	INCR R0
	MVO R0,V2
T9:
T8:
	; 	IF CONT1.LEFT THEN IF X1>0 THEN X1=X1-1
	MVI 511,R0
	COMR R0
	ANDI #8,R0
	TSTR R0
	BEQ T11
	MVI V1,R0
	CMPI #0,R0
	BLE T12
	MVI V1,R0
	DECR R0
	MVO R0,V1
T12:
T11:
	; 	IF CONT1.RIGHT THEN IF X1<168 THEN X1=X1+1
	MVI 511,R0
	COMR R0
	ANDI #2,R0
	TSTR R0
	BEQ T14
	MVI V1,R0
	CMPI #168,R0
	BGE T15
	MVI V1,R0
	INCR R0
	MVO R0,V1
T15:
T14:
	; 	IF CONT1.BUTTON THEN SOUND 0,100,15 ELSE SOUND 0,,0 ' beeper
	MVI 511,R0
	COMR R0
	ANDI #224,R0
	TSTR R0
	BEQ T17
	MVII #100,R0
	MVO R0,$01f0
	SWAP R0
	MVO R0,$01f4
	MVII #15,R0
	MVO R0,$01fb
	B T18
T17:
	CLRR R0
	MVO R0,$01fb
T18:
	; 	END
	RETURN
	ENDP
	; 
	; drawings:
	; DRAWINGS
Q1:	; 	BITMAP "10011001"
	; 	BITMAP "11111111"
	DECLE 65433
	; 	BITMAP "01011010"
	; 	BITMAP "01111110"
	DECLE 32346
	; 	BITMAP "00111100"
	; 	BITMAP "00100100"
	DECLE 9276
	; 	BITMAP "00100100"
	; 	BITMAP "01100110"
	DECLE 26148
	; 
	; 	BITMAP "00011000"
	; 	BITMAP "00011000"
	DECLE 6168
	; 	BITMAP "00111100"
	; 	BITMAP "00100100"
	DECLE 9276
	; 	BITMAP "00111100"
	; 	BITMAP "00111100"
	DECLE 15420
	; 	BITMAP "01111110"
	; 	BITMAP "11111111"
	DECLE 65406
	; 
	; 	BITMAP "00011000"
	; 	BITMAP "00011000"
	DECLE 6168
	; 	BITMAP "01111110"
	; 	BITMAP "00011000"
	DECLE 6270
	; 	BITMAP "00011000"
	; 	BITMAP "00111100"
	DECLE 15384
	; 	BITMAP "00100100"
	; 	BITMAP "01100110"
	DECLE 26148
	; 
	; 	BITMAP "01100000"
	; 	BITMAP "11100000"
	DECLE 57440
	; 	BITMAP "01100000"
	; 	BITMAP "01111111"
	DECLE 32608
	; 	BITMAP "01111110"
	; 	BITMAP "01100110"
	DECLE 26238
	; 	BITMAP "01100110"
	; 	BITMAP "11101110"
	DECLE 61030
        ;
        ; Epilogue for IntyBASIC programs
        ; by Oscar Toledo G.  http://nanochess.org/
        ;
        ; Revision: Jan/30/2014. Moved GRAM code below MOB updates.
        ;                        Added comments.

        ;
        ; Wait for interruption
        ;
_wait:  PROC
        CLRR    R0
        MVO     R0,_int         ; Clears waiting flag
@@1:    CMP     _int,  R0       ; Waits for change
        BEQ     @@1
        JR      R5              ; Returns
        ENDP

        ;
        ; Interruption routine
        ;
_int_vector:     PROC
        BEGIN

        MVO     R0,     $20     ; Activates display
        MVI     $21,    R0      ; Activates mode for 64 definitions of MOB
        MVII    #1,     R0
        MVO     R0,     _int    ; Indicates interrupt happened
        MVI _first_time,R0
        TSTR R0
        BEQ @@vi0
        DECR R0
        MVO R0,_first_time
        MVII    #0,     R0
        MVO     R0,     $28     ; Color stack 0
        MVO     R0,     $2A     ; Color stack 2
        MVO     R0,     $2C     ; Border color
@@vi0:
        ;
        ; Save collision registers for further use
        ;
        MVI     $18,R0
        MVO     R0,_col0
        MVI     $19,R0
        MVO     R0,_col1
        MVI     $1A,R0
        MVO     R0,_col2
        MVI     $1B,R0
        MVO     R0,_col3
        MVI     $1C,R0
        MVO     R0,_col4
        MVI     $1D,R0
        MVO     R0,_col5
        MVI     $1E,R0
        MVO     R0,_col6
        MVI     $1F,R0
        MVO     R0,_col7
        CLRR    R0
        MVO 	R0,$18
        MVO 	R0,$19
        CLRR    R0
        MVO     R0,$1A
        MVO     R0,$1B
        CLRR    R0
        MVO     R0,$1C
        MVO     R0,$1D
        CLRR    R0
        MVO 	R0,$1E
        MVO     R0,$1F

        ;
        ; Updates sprites (MOBs)
        ;
        MVII #_mobs,R4
        MVII #$0,R5     ; X-coordinates
        MVII #8,R1
@@vi2:  MVI@ R4,R0
        MVO@ R0,R5
        MVI@ R4,R0
        MVO@ R0,R5
        MVI@ R4,R0
        MVO@ R0,R5
        DECR R1
        BNE @@vi2

        ;
        ; Detect GRAM definition
        ;
        MVI _load_gram,R0
        TSTR R0
        BEQ @@vi1
        CLRR R0
        MVO R0,_load_gram
        MVI _gram_bitmap,R4
        MVI _gram_target,R1
        SLL R1,2
        SLL R1,1
        ADDI #$3800,R1
        MOVR R1,R5
        MVI _gram_total,R0
@@vi3:
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        MVI@    R4,     R1
        MVO@    R1,     R5
        SWAP    R1
        MVO@    R1,     R5
        DECR R0
        BNE @@vi3
@@vi1:
        ;
        ; Random number generator
        ;
MACRO _ROR
	RRC R0,1
	MOVR R0,R1
	SLR R1,2
	SLR R1,2
	ANDI #$0800,R1
	SLR R1,2
	SLR R1,2
	ANDI #$007F,R0
	XORR R1,R0
ENDM
        MVI _rand,R0
        SETC
        _ROR
        XOR _frame,R0
        _ROR
        XOR _rand,R0
        _ROR
        XORI #9,R0
        MVO R0,_rand

        ; Increase frame number
        MVI _frame,R0
        INCR R0
        MVO R0,_frame

        RETURN
        ENDP
    
        ORG $330,$330,"-RWB"
        ;
        ; 16-bits variables
        ;
_frame:     RMB 1       ; Current frame
_read:      RMB 1       ; Pointer to DATA
_gram_bitmap:   RMB 1   ; Bitmap for definition
_screen:    RMB 1       ; Pointer to current screen position
_color:     RMB 1       ; Current color
_mobs:      RMB 3*8     ; MOB buffer
_col0:      RMB 1       ; Collision status for MOB0
_col1:      RMB 1       ; Collision status for MOB1
_col2:      RMB 1       ; Collision status for MOB2
_col3:      RMB 1       ; Collision status for MOB3
_col4:      RMB 1       ; Collision status for MOB4
_col5:      RMB 1       ; Collision status for MOB5
_col6:      RMB 1       ; Collision status for MOB6
_col7:      RMB 1       ; Collision status for MOB7

SCRATCH:    ORG $100,$100,"-RWBN"
        ;
        ; 8-bits variables
        ;
ISRVEC:     RMB 2       ; Pointer to ISR vector (require by Intellivision ROM)
_int:       RMB 1       ; Signals interrupt received
_rand:      RMB 1       ; Pseudo-random value
_load_gram: RMB 1       ; Signals GRAM definition waiting
_gram_target:   RMB 1   ; Contains GRAM card number
_gram_total:    RMB 1   ; Contains total GRAM cards for definition
_first_time:    RMB 1   ; Signals program started for first time
V3:	RMB 1	; X
V1:	RMB 1	; X1
V2:	RMB 1	; Y1
_SCRATCH:	EQU $

SYSTEM:	ORG $2F0, $2F0, "-RWBN"
STACK:	RMB 32
_SYSTEM:	EQU $
